{$MODE DELPHI}
uses
  SysUtils, testlib;

Const 
  E = 1e-4;

Type
  TPoint = Record
    X, Y: Extended;
  End;
  tvector = tpoint;
Var
  K1, K2: Integer;
  A1, A2, B1, B2: TPoint;

function GetVector(p1,p2:tpoint):tvector;
begin
  Result.X:=p2.X-p1.X;
  Result.Y:=p2.Y-p1.Y;
end;

function scamul(v1,v2:tvector):extended;
begin
  scamul:=v1.X*v2.X+v1.Y*v2.Y;
end;

Function PointEquil(A, B: TPoint): Boolean;
Begin
  PointEquil := (Abs(A.X - B.X) < E) and (Abs(A.Y - B.Y) < E);
End;

var
  center,p:tpoint;
  r:integer;
begin
  center.X:=inf.readinteger;
  center.Y:=inf.ReadInteger;
  r:=inf.readinteger;
  p.X:=inf.readinteger;
  p.Y:=inf.ReadInteger;
  K1 := ans.ReadInteger;
  K2 := ouf.ReadInteger;
  If K1 <> K2 Then Quit(_WA, '');
  If K1 = 0 Then Quit(_OK, '');
  A1.X := ans.ReadReal;
  A1.Y := ans.ReadReal;
  B1.X := ouf.ReadReal;
  B1.Y := ouf.ReadReal;

  If K1 = 1 Then 
    If PointEquil(A1, B1) Then Quit(_OK, '')
                          Else Quit(_WA, '')   
  Else Begin
    A2.X := ans.ReadReal;
    A2.Y := ans.ReadReal;
    B2.X := ouf.ReadReal;
    B2.Y := ouf.ReadReal;



    If (PointEquil(A1, B1) and PointEquil(A2, B2)) or
       (PointEquil(A2, B1) and PointEquil(A1, B2)) Then Quit(_OK, '')
                                                   Else Quit(_WA, '');  
  End;
end.